package magic.microedition.lcdui;

import javax.microedition.lcdui.game.GameCanvas;

public abstract class Kanvas extends GameCanvas{
	
	
	
    public static boolean FullScreen=false;
	
	public static boolean autoScreenSize=false;
	
	public static boolean noKeyCodeConv=false;
	
	public static int screenW=240;
	
	
	public static int screenH=320;
	
	
	public static int[]codes= (new int[] { //// 2468,5,1379 ңABCD
					
			0, 50, 52, 0, 0, 54, 56, 0, 53, 49, 
			
			51, 55, 57
			
		});
	
	
	public static int[]mapfrom = (new int[] {
			
			-7, -6, -5, -4, -3, -2, -1, 49, 50, 51, 
			
			52, 53, 54, 55, 56, 57, 48, 42, 35, 0, 
			
			0, 0, 0, 0, 0
		});
		
	public static int[]mapto = (new int[] {
			
			-22, -21, -20, -5, -2, -6, -1, 49, 50, 51, 
			
			52, 53, 54, 55, 56, 57, 48, 42, 35, 0, 
			
			0, 0, 0, 0, 0
		});
	

	
	protected Kanvas(){
	
		super(false);
		
		setFullScreenMode(FullScreen);
		
		codeInit();
		
	}
		
		
	protected Kanvas(boolean flag){
	
		super(flag);		
		
		setFullScreenMode(FullScreen);
			
		codeInit();
		
	}
	
	
//////////////////////////////////////////////////////////////////////////		
	

	private  void codeInit(){
	
		
		for (int i = 0; i < 13; i++)
			
			if (i != 0 && i != 3 && i != 4 && i != 7)
				
				codes[i] = keyCodeConvert(super.getKeyCode(i));
		
		
	}

	
	private int keyCodeConvert(int i){
	
	
		if (noKeyCodeConv)
			
			return i;
		
		for (int j = 0; j < 25; j++)
			
			if (mapfrom[j] == i){
				
				//System.out.println("Conv ing"+mapfrom[j]+" to "+mapto[j]);
				
				return mapto[j];
				
			}
				

		return i;
	}

	protected void keyPressed(int i){
		
			
		keyPressee(keyCodeConvert(i));
		
	}

	protected void keyReleased(int i){
	
		keyReleasee(keyCodeConvert(i));
		
	}

	protected void keyRepeated(int i){
		
		keyRepeatee(keyCodeConvert(i));
		
	}

	protected void keyPressee(int i){
		
	
	}

	protected void keyReleasee(int i){
		
	
	}

	protected void keyRepeatee(int i){
		
	
	}

	public int getGameAction(int i){
	
		if (noKeyCodeConv)
			
			return super.getGameAction(i);
		
		boolean flag = false;
		
		for (int k = 0; k < 25; k++){
		
			if (mapto[k] != i)
				
				continue;
			
			flag = true;
			
			int j = super.getGameAction(mapfrom[k]);
			
			if (j != 0)
				
				return j;
		}

		return flag ? 0 : super.getGameAction(i);
	}

	public int getKeyCode(int i){
	
		if (noKeyCodeConv)
			
			return super.getKeyCode(i);
		
		else
			return codes[i] == 0 ? super.getKeyCode(i) : codes[i];
	}

	public String getKeyName(int i){
	
		if (noKeyCodeConv)
			
			return super.getKeyName(i);
		
		for (int j = 0; j < 25; j++)
			
			if (mapto[j] == i)
				
				return super.getKeyName(mapfrom[j]);

		return super.getKeyName(i);
	}
	
	

	public int getWidth(){
	
		return screenW;
	}

	public int getHeight(){
	
		return screenH;
	}
	

	protected void sizeChanged(int i, int j){
	
		if (autoScreenSize){
		
			screenH = j;
			
			screenW = i;
		}
		
		setFullScreenMode(FullScreen);
		
		//System.out.println("Res. " + screenW + "x" + screenH);
			
	}
	
	
    static{
    	
    	kMagic.init();
    }
	

}