package zip;

import java.util.Calendar;
import java.util.Date;

public class ZipEntry {

    private byte namebytes[] = null;
    public int namelen;
    public int dostime, size, compressedSize, offset, crc;
    public short method;
    public String name;
    public int flag;

    public ZipEntry(String n) {
        if (n != null) {
            name = n.replace('\\', '/');
            namebytes = name.getBytes();
            namelen = namebytes.length;
        }
    }

    public void setname(byte n[], int off, int len) {
        namelen = len;
        name = new String(n, off, len).replace('\\', '/');
        namebytes = name.getBytes();
    }

    public void setTime(long time) {
        Calendar w = Calendar.getInstance();
        if (time > 0) {
            w.setTime(new Date(time));
        }
        dostime = (w.get(1) - 1980) << 25 | (w.get(2) + 1) << 21 | (w.get(5)) << 16 | (w.get(11)) << 11 | (w.get(12)) << 5 | (w.get(13)) >> 1;
    }

    public void setMethod(int method) {
        this.method = (short) method;
    }

    public int getMethod() {
        return method;
    }

    public byte[] getNamebytes() {
        return namebytes;
    }

    public boolean isDirectory() {
        return name.endsWith("/");
    }

    public String toString() {
        return name;
    }
}
